///////////////////////////////////////////////////////////////////////
//
// TAMthLnk.h : interface and definitions for techexplorer  MthLnk 
//              AddIn
//
///////////////////////////////////////////////////////////////////////
//
// Copyright (c) 1997-98 by the IBM Corporation. All Rights Reserved.
//
// Author:          Angel  L. Diaz    aldiaz@us.ibm.com
//                  Robert S. Sutor   sutor@us.ibm.com
//
// IBM MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR
// ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING OR MODIFYING
// THIS SOFTWARE OR ITS DERIVATIVES.
//
///////////////////////////////////////////////////////////////////////

#ifndef _IBM_TAMTHLNK_H
#define _IBM_TAMTHLNK_H

#include "resource.h"		// main symbols
#include "TaApi.h"
#include "mathlink.h"

// =====================================================================
//
// CTAMthLnkApp
//
// =====================================================================

// The MthLnk add-in can send a string to a Mathematica kernel that 
// is then executed by the kernel.  The answe is returned and displayed 
// in a modal dialog box.  This add-in registers the 
// application/x-mathlink-string MIME type.

class CTAMthLnkApp : public CWinApp
{
  public: // Constructor/Destructor
	                             CTAMthLnkApp();
  static CTAMthLnkApp           *GetAddInDllObject();
    
  public: // Add-In/Instance operations
	TAError                      Initialize();
    TAError                      Shutdown();

    TAError                      New(AddInInstance *pAddInInstance, LPCSTR sMimeType);
    TAError                      Destroy(AddInInstance *pAddInInstance);

  public: // Evaluation API
	TAError                      Evaluate(AddInInstance *pAddInInstance, LPCSTR sMimeType, LPCSTR sAppInput);

  public: // Asynchronous operations
    TAError                      LocalFileIsReady(AddInInstance *pAddInInstance, LPCSTR sFileName);

  public: // Utillity
	LPCSTR                       GetMimeType();

  protected: 
	void                         CleanUpWhiteSpace( CString &rInput );

  private:  
	CString                      f_sMimeType; // MIME type; file extension; add-in description|MIME type; file extension; add-in description|...

	CPtrList                     f_Instances;

    MLENV ep;
    MLINK lp;
};

#endif 
